/*
    Ghosts, Ghouls, & Goblins mod by Greaserpirate
*/

#define TEAM_ALPHA	TEAM_ALPHA
#define TEAM_OMEGA	TEAM_OMEGA
#define TEAM_KAPPA	TEAM_KAPPA
#define TEAM_SIGMA	TEAM_SIGMA

struct gggservmode : servmode
{
    /* This is called whenever a player enters the game. */
    void entergame(clientinfo *ci)
    {
	ancmsgft(ci->clientnum, S_GUIBACK, CON_EVENT, "Welcome to Ghosts, Ghouls, and Goblins mode.");
	if (numteams(gamemode, mutators) == 3)
		ancmsgft(ci->clientnum, S_GUIBACK, CON_EVENT, "\fbAlpha \fwbeats \frOmega, Omega \fwbeats \fKappa, \fwand \fgKappa \fwbeats \fbAlpha");
	else if (numteams(gamemode, mutators) == 4)
		ancmsgft(ci->clientnum, S_GUIBACK, CON_EVENT, "\fbAlpha \fwbeats \frOmega, Omega \fwbeats \fgKappa, Kappa \fwbeats \fySigma, \fwand \fySigma \fwbeats \fbAlpha");
	else
		ancmsgft(ci->clientnum, S_GUIBACK, CON_EVENT, "Unsure about number of teams");
    }

    /* This is called whenever a player leaves the game */
    void leavegame(clientinfo *ci, bool disconnecting = false)
    {
    }

    /* This is called every time a player moves */
    void moved(clientinfo *ci, const vec &oldpos, const vec &newpos)
    {
    }

    /* This is called when the server needs to know if a player can join a game */
    bool canspawn(clientinfo *ci, bool tryspawn = false)
    {
        /* Everybody can join this party */
        return true;
    }

    /* This is called whenever someone spawns */
    void spawned(clientinfo *ci)
    {
	if (m_insta(gamemode, mutators)) //if it's Instagib,
	{
		//players spawn an amount of health decided by "ggginstahealth"
		ci->state.health = GAME(ggginstahealth);
		sendf(-1, 1, "ri4", N_REGEN, ci->clientnum, GAME(ggginstahealth), 0);
	}
    }

    /* This is called when a player kills another player.  Returns the number of
       points assigned. */
    int points(clientinfo *victim, clientinfo *actor)
    {
        if(victim==actor || victim->team == actor->team) return -1;
        return 1;
    }

    /* This is called whenever someone dies */
    void died(clientinfo *victim, clientinfo *actor = NULL)
    {
    }

    /* In theory, this is called when someone changes teams.  I don't think
       it is actually used in practice. */
    void changeteam(clientinfo *ci, int oldteam, int newteam)
    {
    }

    /* Change the team that a player is on and broadcast it to everyone */
    void setteam(clientinfo *ci, int team)
    {
    }
    
    /* Called when a client first connects.  Used for low level networking stuff
       if there is any extra information we want to append to the packet. */
    void initclient(clientinfo *ci, packetbuf &p, bool connecting)
    {
    }

    /* Called every frame */
    void update()
    {
    }

    /* Called when the server is reset */
    void reset(bool empty)
    {
    }

    /* No clue */
    void layout()
    {
    }

    /* This is called when intermission begins */
    void intermission()
    {
    }

    //check if a targeted player has an advantage over its attacker(Added by Greaser)
    bool hasadvantage(clientinfo *target, clientinfo *actor)
    {
	if (numteams(gamemode, mutators) == 3)
	{
		//3 teams: Alpha beats Omega, Omega beats kappa, kappa beats Alpha
        	if (((target->team == TEAM_ALPHA) && (actor->team == TEAM_OMEGA)) || ((target->team == TEAM_OMEGA) && (actor->team == TEAM_KAPPA)) || ((target->team == TEAM_KAPPA) && (actor->team == TEAM_ALPHA))) return true;
	}
	if (numteams(gamemode, mutators) == 4)
	{
		//4 teams: Alpha beats Omega, Omega beats kappa, kappa beats sigma, sigma beats Alpha
		if (((target->team == TEAM_ALPHA) && (actor->team == TEAM_OMEGA)) || ((target->team == TEAM_OMEGA) && (actor->team == TEAM_KAPPA)) || ((target->team == TEAM_KAPPA) && (actor->team == TEAM_SIGMA)) || ((target->team == TEAM_SIGMA && actor->team == TEAM_ALPHA))) return true;
	}
	return false; //default
    }

    /* This is called when someone actually deals damage to someone else */
    bool damage(clientinfo *target,
                clientinfo *actor,
                int damage,
                int weap,
                int flags,
                const ivec &hitpush = ivec(0, 0, 0))
    {
        return true;
    }

    /* Called before damage is dealt */
    void dodamage(clientinfo *target,
                  clientinfo *actor,
                  int &damage,
                  int &hurt,
                  int &weap,
                  int &flags,
                  const ivec &hitpush = ivec(0, 0, 0))
    {
        //check for advantage, if the target has one, 
        if (hasadvantage(target,actor))
        {
	    //undo damage already done
	    target->state.health += damage;
	    //head damage is scaled by "gggstronghead"
	    if (hithead(flags))
	    {
		damage *= GAME(gggstronghead); //scale damage
		//add one damage points for rounding, but not if the weap is Flamer
		if ((weap != 5) && (weap != 15) && (GAME(gggstronghead) != 0))
		{
			damage += 1;
		}
	    }
	    
	    //body damage is scaled by "gggstrongbody"
	    else
	    {
		damage *= GAME(gggstrongbody); //scale damage
		//add one damage points for rounding, but not if the weap is Flamer
		if ((weap != 5) && (weap != 15) && (GAME(gggstrongbody) != 0))
		{
			damage += 1;
		}
	    }

            /* re-apply damage */
            target->state.health -= damage;
            if (target->state.health <= 0)
                flags |= HIT_KILL;
        }
	else if (hasadvantage(actor, target)) //if the attacker has the advantage:
	{
	    //same, but w/ "gggweakhead" and "gggweakbody"
	    target->state.health += damage;
	    if (hithead(flags))
	    {
		damage *= GAME(gggweakhead); //scale damage
		//add one damage points for rounding, but not if the weap is Flamer
		if ((weap != 5) && (weap != 15) && (GAME(gggweakhead) != 0))
		{
			damage += 1;
		}
	    }
	    
	    //body damage
	    else
	    {
		damage *= GAME(gggweakbody); //scale damage
		//add one damage points for rounding, but not if the weap is Flamer
		if ((weap != 5) && (weap != 15) && (GAME(gggweakbody) != 0))
		{
			damage += 1;
		}
	    }

            /* re-apply damage */
            target->state.health -= damage;
            if (target->state.health <= 0)
                flags |= HIT_KILL;
	}
    }

    /* Called every frame with regen info */
    void regen(clientinfo *ci, int &total, int &amt, int &delay)
    {
    }

} gggmut;
